// A Bison parser, made by GNU Bison 3.7.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2020 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 31 "src/parser.yy"

#include <iostream>

#include "driver.h"

void yyerror(bpftrace::Driver &driver, const char *s);

#line 49 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"


#include "parser.tab.hh"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 4 "src/parser.yy"
namespace  bpftrace  {
#line 147 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"

  /// Build a parser object.
   Parser :: Parser  (bpftrace::Driver &driver_yyarg, void *yyscanner_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      yyscanner (yyscanner_yyarg)
  {}

   Parser ::~ Parser  ()
  {}

   Parser ::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/



  // by_state.
   Parser ::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

   Parser ::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
   Parser ::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
   Parser ::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

   Parser ::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

   Parser ::symbol_kind_type
   Parser ::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

   Parser ::stack_symbol_type::stack_symbol_type ()
  {}

   Parser ::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_attach_point: // attach_point
        value.YY_MOVE_OR_COPY< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.YY_MOVE_OR_COPY< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.YY_MOVE_OR_COPY< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.YY_MOVE_OR_COPY< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.YY_MOVE_OR_COPY< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.YY_MOVE_OR_COPY< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.YY_MOVE_OR_COPY< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.YY_MOVE_OR_COPY< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.YY_MOVE_OR_COPY< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.YY_MOVE_OR_COPY< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes: // probes
        value.YY_MOVE_OR_COPY< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.YY_MOVE_OR_COPY< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.YY_MOVE_OR_COPY< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.YY_MOVE_OR_COPY< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.YY_MOVE_OR_COPY< int > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.YY_MOVE_OR_COPY< long > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

   Parser ::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes: // probes
        value.move< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.move< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.move< int > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< long > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.move< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
   Parser ::stack_symbol_type&
   Parser ::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_attach_point: // attach_point
        value.copy< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.copy< ast::AttachPointList * > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.copy< ast::Call * > (that.value);
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.copy< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.copy< ast::ExpressionList * > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.copy< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.copy< ast::Map * > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.copy< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.copy< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.copy< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_probes: // probes
        value.copy< ast::ProbeList * > (that.value);
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.copy< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.copy< ast::StatementList * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.copy< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.copy< int > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.copy< long > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

   Parser ::stack_symbol_type&
   Parser ::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList * > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (that.value);
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList * > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_probes: // probes
        value.move< ast::ProbeList * > (that.value);
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.move< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.move< int > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< long > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
   Parser ::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
   Parser ::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YYUSE (yykind);
        yyo << ')';
      }
  }
#endif

  void
   Parser ::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
   Parser ::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
   Parser ::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
   Parser ::debug_stream () const
  {
    return *yycdebug_;
  }

  void
   Parser ::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


   Parser ::debug_level_type
   Parser ::debug_level () const
  {
    return yydebug_;
  }

  void
   Parser ::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

   Parser ::state_type
   Parser ::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
   Parser ::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
   Parser ::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
   Parser ::operator() ()
  {
    return parse ();
  }

  int
   Parser ::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, yyscanner));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_attach_point: // attach_point
        yylhs.value.emplace< ast::AttachPoint * > ();
        break;

      case symbol_kind::S_attach_points: // attach_points
        yylhs.value.emplace< ast::AttachPointList * > ();
        break;

      case symbol_kind::S_call: // call
        yylhs.value.emplace< ast::Call * > ();
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        yylhs.value.emplace< ast::Expression * > ();
        break;

      case symbol_kind::S_vargs: // vargs
        yylhs.value.emplace< ast::ExpressionList * > ();
        break;

      case symbol_kind::S_int: // int
        yylhs.value.emplace< ast::Integer * > ();
        break;

      case symbol_kind::S_map: // map
        yylhs.value.emplace< ast::Map * > ();
        break;

      case symbol_kind::S_param: // param
        yylhs.value.emplace< ast::PositionalParameter * > ();
        break;

      case symbol_kind::S_pred: // pred
        yylhs.value.emplace< ast::Predicate * > ();
        break;

      case symbol_kind::S_probe: // probe
        yylhs.value.emplace< ast::Probe * > ();
        break;

      case symbol_kind::S_probes: // probes
        yylhs.value.emplace< ast::ProbeList * > ();
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        yylhs.value.emplace< ast::Statement * > ();
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        yylhs.value.emplace< ast::StatementList * > ();
        break;

      case symbol_kind::S_var: // var
        yylhs.value.emplace< ast::Variable * > ();
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        yylhs.value.emplace< int > ();
        break;

      case symbol_kind::S_INT: // "integer"
        yylhs.value.emplace< long > ();
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        yylhs.value.emplace< std::string > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // program: c_definitions probes
#line 158 "src/parser.yy"
                                     { driver.root_ = new ast::Program(yystack_[1].value.as < std::string > (), yystack_[0].value.as < ast::ProbeList * > ()); }
#line 1082 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 3: // c_definitions: "preprocessor directive" c_definitions
#line 162 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\n" + yystack_[0].value.as < std::string > (); }
#line 1088 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 4: // c_definitions: "struct definition" c_definitions
#line 163 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1094 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 5: // c_definitions: "enum" c_definitions
#line 164 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1100 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 6: // c_definitions: %empty
#line 165 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = std::string(); }
#line 1106 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 7: // probes: probes probe
#line 169 "src/parser.yy"
                             { yylhs.value.as < ast::ProbeList * > () = yystack_[1].value.as < ast::ProbeList * > (); yystack_[1].value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1112 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 8: // probes: probe
#line 170 "src/parser.yy"
                             { yylhs.value.as < ast::ProbeList * > () = new ast::ProbeList; yylhs.value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1118 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 9: // probe: attach_points pred block
#line 175 "src/parser.yy"
                {
                  if (!driver.listing_)
                    yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[2].value.as < ast::AttachPointList * > (), yystack_[1].value.as < ast::Predicate * > (), yystack_[0].value.as < ast::StatementList * > ());
                  else
                  {
                    error(yylhs.location, "unexpected listing query format");
                    YYERROR;
                  }
                }
#line 1132 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 10: // probe: attach_points "end of file"
#line 185 "src/parser.yy"
                {
                  if (driver.listing_)
                    yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[1].value.as < ast::AttachPointList * > (), nullptr, nullptr);
                  else
                  {
                    error(yylhs.location, "unexpected end of file, expected {");
                    YYERROR;
                  }
                }
#line 1146 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 11: // attach_points: attach_points "," attach_point
#line 197 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = yystack_[2].value.as < ast::AttachPointList * > (); yystack_[2].value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1152 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 12: // attach_points: attach_point
#line 198 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = new ast::AttachPointList; yylhs.value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1158 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 13: // attach_point: attach_point_def
#line 202 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1164 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 14: // attach_point_def: attach_point_def ident
#line 206 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1170 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 15: // attach_point_def: attach_point_def "string"
#line 210 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\"" + std::regex_replace(yystack_[0].value.as < std::string > (), std::regex("\""), "\\\"") + "\""; }
#line 1176 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 16: // attach_point_def: attach_point_def "path"
#line 211 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1182 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 17: // attach_point_def: attach_point_def "integer"
#line 212 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + std::to_string(yystack_[0].value.as < long > ()); }
#line 1188 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 18: // attach_point_def: attach_point_def ":"
#line 213 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ":"; }
#line 1194 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 19: // attach_point_def: attach_point_def "."
#line 214 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "."; }
#line 1200 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 20: // attach_point_def: attach_point_def "+"
#line 215 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "+"; }
#line 1206 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 21: // attach_point_def: attach_point_def "*"
#line 216 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "*"; }
#line 1212 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 22: // attach_point_def: attach_point_def "["
#line 217 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "["; }
#line 1218 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 23: // attach_point_def: attach_point_def "]"
#line 218 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "]"; }
#line 1224 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 24: // attach_point_def: attach_point_def param
#line 220 "src/parser.yy"
                {
                  if (yystack_[0].value.as < ast::PositionalParameter * > ()->ptype != PositionalParameterType::positional)
                  {
                    error(yylhs.location, "Not a positional parameter");
                    YYERROR;
                  }
                  // "Un-parse" the positional parameter back into text so
                  // we can give it to the AttachPointParser. This is kind of
                  // a hack but there doesn't look to be any other way.
                  yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "$" + std::to_string(yystack_[0].value.as < ast::PositionalParameter * > ()->n);
                  delete yystack_[0].value.as < ast::PositionalParameter * > ();
                }
#line 1241 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 25: // attach_point_def: %empty
#line 232 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = ""; }
#line 1247 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 26: // pred: "/" expr "end predicate"
#line 236 "src/parser.yy"
                                 { yylhs.value.as < ast::Predicate * > () = new ast::Predicate(yystack_[1].value.as < ast::Expression * > (), yylhs.location); }
#line 1253 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 27: // pred: %empty
#line 237 "src/parser.yy"
                                  { yylhs.value.as < ast::Predicate * > () = nullptr; }
#line 1259 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 28: // param: "positional parameter"
#line 242 "src/parser.yy"
                      {
                        try {
                          long n = std::stol(yystack_[0].value.as < std::string > ().substr(1, yystack_[0].value.as < std::string > ().size()-1));
                          if (n == 0) throw std::exception();
                          yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::positional, n, yylhs.location);
                        } catch (std::exception const& e) {
                          error(yystack_[0].location, "param " + yystack_[0].value.as < std::string > () + " is out of integer range [1, " +
                                std::to_string(std::numeric_limits<long>::max()) + "]");
                          YYERROR;
                        }
                      }
#line 1275 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 29: // param: "$#"
#line 253 "src/parser.yy"
                           { yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::count, 0, yylhs.location); }
#line 1281 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 30: // block: "{" stmt_list "}"
#line 257 "src/parser.yy"
                                      { yylhs.value.as < ast::StatementList * > () = yystack_[1].value.as < ast::StatementList * > (); }
#line 1287 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 31: // stmt_list: expr_stmt ";" stmt_list
#line 264 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[2].value.as < ast::Statement * > ()); }
#line 1293 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 32: // stmt_list: expr_stmt
#line 265 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->push_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1299 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 33: // stmt_list: block_stmt stmt_list
#line 269 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[1].value.as < ast::Statement * > ()); }
#line 1305 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 34: // stmt_list: %empty
#line 270 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; }
#line 1311 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 35: // block_stmt: loop_stmt
#line 274 "src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1317 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 36: // block_stmt: if_stmt
#line 275 "src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1323 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 37: // expr_stmt: expr
#line 279 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = new ast::ExprStatement(yystack_[0].value.as < ast::Expression * > (), yystack_[0].location); }
#line 1329 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 38: // expr_stmt: jump_stmt
#line 280 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1335 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 39: // expr_stmt: assign_stmt
#line 285 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1341 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 40: // jump_stmt: "break"
#line 289 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(token::BREAK, yylhs.location); }
#line 1347 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 41: // jump_stmt: "continue"
#line 290 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(token::CONTINUE, yylhs.location); }
#line 1353 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 42: // jump_stmt: "return"
#line 291 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(token::RETURN, yylhs.location); }
#line 1359 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 43: // loop_stmt: "unroll" "(" int ")" block
#line 295 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < ast::Integer * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1365 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 44: // loop_stmt: "unroll" "(" param ")" block
#line 296 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < ast::PositionalParameter * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1371 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 45: // loop_stmt: "while" "(" expr ")" block
#line 297 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::While(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location); }
#line 1377 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 46: // if_stmt: "if" "(" expr ")" block
#line 301 "src/parser.yy"
                                                       { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1383 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 47: // if_stmt: "if" "(" expr ")" block "else" block_or_if
#line 302 "src/parser.yy"
                                                       { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::StatementList * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1389 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 48: // block_or_if: block
#line 306 "src/parser.yy"
                             { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); }
#line 1395 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 49: // block_or_if: if_stmt
#line 307 "src/parser.yy"
                             { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->emplace_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1401 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 50: // assign_stmt: tuple_access_expr "=" expr
#line 312 "src/parser.yy"
                {
                  error(yystack_[2].location + yystack_[0].location, "Tuples are immutable once created. Consider creating a new tuple and assigning it instead.");
                  YYERROR;
                }
#line 1410 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 51: // assign_stmt: map "=" expr
#line 316 "src/parser.yy"
                                     { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), yystack_[0].value.as < ast::Expression * > (), false, yystack_[1].location); }
#line 1416 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 52: // assign_stmt: var "=" expr
#line 317 "src/parser.yy"
                                     { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), yystack_[0].value.as < ast::Expression * > (), false, yystack_[1].location); }
#line 1422 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 53: // assign_stmt: map compound_op unary_expr
#line 319 "src/parser.yy"
                {
                  auto b = new ast::Binop(yystack_[2].value.as < ast::Map * > (), yystack_[1].value.as < int > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), b, true, yylhs.location);
                }
#line 1431 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 54: // assign_stmt: var compound_op unary_expr
#line 324 "src/parser.yy"
                {
                  auto b = new ast::Binop(yystack_[2].value.as < ast::Variable * > (), yystack_[1].value.as < int > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), b, true, yylhs.location);
                }
#line 1440 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 55: // primary_expr: "identifier"
#line 331 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Identifier(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1446 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 56: // primary_expr: int
#line 332 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Integer * > (); }
#line 1452 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 57: // primary_expr: "string"
#line 333 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::String(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1458 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 58: // primary_expr: "stack_mode"
#line 334 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::StackMode(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1464 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 59: // primary_expr: "builtin"
#line 335 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1470 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 60: // primary_expr: "call_builtin"
#line 336 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1476 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 61: // primary_expr: "(" expr ")"
#line 337 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[1].value.as < ast::Expression * > (); }
#line 1482 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 62: // primary_expr: param
#line 338 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::PositionalParameter * > (); }
#line 1488 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 63: // primary_expr: map_or_var
#line 339 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1494 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 64: // primary_expr: "(" expr "," vargs ")"
#line 341 "src/parser.yy"
                {
                  auto args = new ast::ExpressionList;
                  args->emplace_back(yystack_[3].value.as < ast::Expression * > ());
                  args->insert(args->end(), yystack_[1].value.as < ast::ExpressionList * > ()->begin(), yystack_[1].value.as < ast::ExpressionList * > ()->end());
                  yylhs.value.as < ast::Expression * > () = new ast::Tuple(args, yylhs.location);
                }
#line 1505 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 65: // postfix_expr: primary_expr
#line 350 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1511 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 66: // postfix_expr: postfix_expr "." ident
#line 352 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < std::string > (), yystack_[1].location); }
#line 1517 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 67: // postfix_expr: postfix_expr "->" ident
#line 353 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(new ast::Unop(token::MUL, yystack_[2].value.as < ast::Expression * > (), yystack_[1].location), yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1523 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 68: // postfix_expr: tuple_access_expr
#line 355 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1529 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 69: // postfix_expr: postfix_expr "[" expr "]"
#line 357 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::ArrayAccess(yystack_[3].value.as < ast::Expression * > (), yystack_[1].value.as < ast::Expression * > (), yystack_[2].location + yystack_[0].location); }
#line 1535 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 70: // postfix_expr: call
#line 358 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Call * > (); }
#line 1541 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 71: // postfix_expr: map_or_var "++"
#line 359 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::INCREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1547 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 72: // postfix_expr: map_or_var "--"
#line 360 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::DECREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1553 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 73: // postfix_expr: "++" ident
#line 362 "src/parser.yy"
                                          { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1559 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 74: // postfix_expr: "--" ident
#line 363 "src/parser.yy"
                                          { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1565 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 75: // tuple_access_expr: postfix_expr "." "integer"
#line 368 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < long > (), yystack_[0].location); }
#line 1571 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 76: // unary_expr: unary_op cast_expr
#line 374 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(yystack_[1].value.as < int > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1577 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 77: // unary_expr: postfix_expr
#line 375 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1583 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 78: // unary_expr: "++" map_or_var
#line 376 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::INCREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1589 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 79: // unary_expr: "--" map_or_var
#line 377 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::DECREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1595 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 80: // unary_expr: ident "--"
#line 379 "src/parser.yy"
                                     { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1601 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 81: // unary_expr: ident "++"
#line 380 "src/parser.yy"
                                     { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1607 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 82: // unary_op: "*"
#line 384 "src/parser.yy"
                       { yylhs.value.as < int > () = token::MUL; }
#line 1613 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 83: // unary_op: "~"
#line 385 "src/parser.yy"
                       { yylhs.value.as < int > () = token::BNOT; }
#line 1619 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 84: // unary_op: "!"
#line 386 "src/parser.yy"
                       { yylhs.value.as < int > () = token::LNOT; }
#line 1625 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 85: // unary_op: "-"
#line 387 "src/parser.yy"
                       { yylhs.value.as < int > () = token::MINUS; }
#line 1631 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 86: // expr: conditional_expr
#line 391 "src/parser.yy"
                                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1637 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 87: // conditional_expr: logical_or_expr
#line 395 "src/parser.yy"
                                                                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1643 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 88: // conditional_expr: logical_or_expr "?" expr ":" conditional_expr
#line 396 "src/parser.yy"
                                                                 { yylhs.value.as < ast::Expression * > () = new ast::Ternary(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::Expression * > (), yylhs.location); }
#line 1649 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 89: // logical_or_expr: logical_and_expr
#line 401 "src/parser.yy"
                                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1655 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 90: // logical_or_expr: logical_or_expr "||" logical_and_expr
#line 402 "src/parser.yy"
                                                     { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1661 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 91: // logical_and_expr: or_expr
#line 406 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1667 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 92: // logical_and_expr: logical_and_expr "&&" or_expr
#line 407 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LAND, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1673 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 93: // or_expr: xor_expr
#line 411 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1679 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 94: // or_expr: or_expr "|" xor_expr
#line 412 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::BOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1685 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 95: // xor_expr: and_expr
#line 416 "src/parser.yy"
                                       { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1691 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 96: // xor_expr: xor_expr "^" and_expr
#line 417 "src/parser.yy"
                                       { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::BXOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1697 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 97: // and_expr: equality_expr
#line 422 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1703 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 98: // and_expr: and_expr "&" equality_expr
#line 423 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::BAND, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1709 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 99: // equality_expr: relational_expr
#line 427 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1715 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 100: // equality_expr: equality_expr "==" relational_expr
#line 428 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::EQ, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1721 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 101: // equality_expr: equality_expr "!=" relational_expr
#line 429 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::NE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1727 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 102: // relational_expr: shift_expr
#line 433 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1733 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 103: // relational_expr: relational_expr "<=" shift_expr
#line 434 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1739 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 104: // relational_expr: relational_expr ">=" shift_expr
#line 435 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::GE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1745 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 105: // relational_expr: relational_expr "<" shift_expr
#line 436 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1751 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 106: // relational_expr: relational_expr ">" shift_expr
#line 437 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::GT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1757 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 107: // shift_expr: addi_expr
#line 441 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1763 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 108: // shift_expr: shift_expr "<<" addi_expr
#line 442 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LEFT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1769 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 109: // shift_expr: shift_expr ">>" addi_expr
#line 443 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::RIGHT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1775 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 110: // muli_expr: cast_expr
#line 447 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1781 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 111: // muli_expr: muli_expr "*" cast_expr
#line 448 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::MUL, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1787 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 112: // muli_expr: muli_expr "/" cast_expr
#line 449 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::DIV, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1793 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 113: // muli_expr: muli_expr "%" cast_expr
#line 450 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::MOD, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1799 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 114: // addi_expr: muli_expr
#line 454 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1805 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 115: // addi_expr: addi_expr "+" muli_expr
#line 455 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::PLUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1811 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 116: // addi_expr: addi_expr "-" muli_expr
#line 456 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1817 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 117: // cast_expr: unary_expr
#line 460 "src/parser.yy"
                                                      { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1823 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 118: // cast_expr: "(" "identifier" ")" cast_expr
#line 461 "src/parser.yy"
                                                      { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[2].value.as < std::string > (), false, false, yystack_[0].value.as < ast::Expression * > (), yystack_[3].location + yystack_[1].location); }
#line 1829 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 119: // cast_expr: "(" "identifier" "*" ")" cast_expr
#line 462 "src/parser.yy"
                                                      { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[3].value.as < std::string > (), true, false, yystack_[0].value.as < ast::Expression * > (), yystack_[4].location + yystack_[2].location); }
#line 1835 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 120: // cast_expr: "(" "identifier" "*" "*" ")" cast_expr
#line 463 "src/parser.yy"
                                                      { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[4].value.as < std::string > (), true, true, yystack_[0].value.as < ast::Expression * > (), yystack_[5].location + yystack_[3].location); }
#line 1841 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 121: // int: "-" "integer"
#line 467 "src/parser.yy"
                             { yylhs.value.as < ast::Integer * > () = new ast::Integer((long)(~(unsigned long)(yystack_[0].value.as < long > ()) + 1), yylhs.location); }
#line 1847 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 122: // int: "integer"
#line 468 "src/parser.yy"
                             { yylhs.value.as < ast::Integer * > () = new ast::Integer(yystack_[0].value.as < long > (), yylhs.location); }
#line 1853 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 123: // ident: "identifier"
#line 472 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1859 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 124: // ident: "builtin"
#line 473 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1865 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 125: // ident: "call"
#line 474 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1871 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 126: // ident: "call_builtin"
#line 475 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1877 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 127: // ident: "stack_mode"
#line 476 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1883 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 128: // call: "call" "(" ")"
#line 480 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 1889 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 129: // call: "call" "(" vargs ")"
#line 481 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1895 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 130: // call: "call_builtin" "(" ")"
#line 482 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 1901 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 131: // call: "call_builtin" "(" vargs ")"
#line 483 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1907 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 132: // call: "identifier" "(" ")"
#line 484 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1913 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 133: // call: "identifier" "(" vargs ")"
#line 485 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1919 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 134: // call: "builtin" "(" ")"
#line 486 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1925 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 135: // call: "builtin" "(" vargs ")"
#line 487 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1931 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 136: // call: "stack_mode" "(" ")"
#line 488 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1937 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 137: // call: "stack_mode" "(" vargs ")"
#line 489 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1943 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 138: // map: "map"
#line 493 "src/parser.yy"
                                  { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1949 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 139: // map: "map" "[" vargs "]"
#line 494 "src/parser.yy"
                                  { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1955 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 140: // var: "variable"
#line 498 "src/parser.yy"
                    { yylhs.value.as < ast::Variable * > () = new ast::Variable(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1961 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 141: // map_or_var: var
#line 502 "src/parser.yy"
                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Variable * > (); }
#line 1967 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 142: // map_or_var: map
#line 503 "src/parser.yy"
                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Map * > (); }
#line 1973 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 143: // vargs: vargs "," expr
#line 507 "src/parser.yy"
                               { yylhs.value.as < ast::ExpressionList * > () = yystack_[2].value.as < ast::ExpressionList * > (); yystack_[2].value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 1979 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 144: // vargs: expr
#line 508 "src/parser.yy"
                               { yylhs.value.as < ast::ExpressionList * > () = new ast::ExpressionList; yylhs.value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 1985 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 145: // compound_op: "<<="
#line 512 "src/parser.yy"
                             { yylhs.value.as < int > () = token::LEFT; }
#line 1991 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 146: // compound_op: "&="
#line 513 "src/parser.yy"
                             { yylhs.value.as < int > () = token::BAND; }
#line 1997 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 147: // compound_op: "|="
#line 514 "src/parser.yy"
                             { yylhs.value.as < int > () = token::BOR; }
#line 2003 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 148: // compound_op: "^="
#line 515 "src/parser.yy"
                             { yylhs.value.as < int > () = token::BXOR; }
#line 2009 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 149: // compound_op: "/="
#line 516 "src/parser.yy"
                             { yylhs.value.as < int > () = token::DIV; }
#line 2015 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 150: // compound_op: "-="
#line 517 "src/parser.yy"
                             { yylhs.value.as < int > () = token::MINUS; }
#line 2021 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 151: // compound_op: "%="
#line 518 "src/parser.yy"
                             { yylhs.value.as < int > () = token::MOD; }
#line 2027 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 152: // compound_op: "*="
#line 519 "src/parser.yy"
                             { yylhs.value.as < int > () = token::MUL; }
#line 2033 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 153: // compound_op: "+="
#line 520 "src/parser.yy"
                             { yylhs.value.as < int > () = token::PLUS; }
#line 2039 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;

  case 154: // compound_op: ">>="
#line 521 "src/parser.yy"
                             { yylhs.value.as < int > () = token::RIGHT; }
#line 2045 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"
    break;


#line 2049 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
   Parser ::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
   Parser ::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
   Parser ::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  //  Parser ::context.
   Parser ::context::context (const  Parser & yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
   Parser ::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        int yychecklim = yylast_ - yyn + 1;
        int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }



  int
   Parser ::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
   Parser ::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short  Parser ::yypact_ninf_ = -209;

  const short  Parser ::yytable_ninf_ = -128;

  const short
   Parser ::yypact_[] =
  {
     170,   170,   170,   170,    53,  -209,  -209,  -209,  -209,  -209,
      85,  -209,    84,  -209,    30,  -209,  -209,  -209,   359,    42,
    -209,  -209,  -209,  -209,  -209,  -209,  -209,  -209,  -209,  -209,
    -209,  -209,  -209,  -209,  -209,  -209,  -209,  -209,  -209,   398,
      69,    23,    69,  -209,  -209,  -209,     1,    98,     9,    87,
    -209,   104,  -209,  -209,   101,  -209,  -209,    32,  -209,  -209,
     359,   103,  -209,    35,    99,    93,    96,   105,    83,   131,
     153,   174,   -12,  -209,  -209,   -19,  -209,  -209,  -209,    40,
     138,  -209,    77,     6,  -209,  -209,  -209,  -209,  -209,     3,
     203,   242,   281,   359,   320,   359,    73,   171,  -209,  -209,
     359,   359,   359,   359,   359,   359,   359,   359,   359,   359,
     359,   359,   359,   359,   359,   359,   359,   359,   359,  -209,
    -209,  -209,  -209,   134,   142,   151,  -209,  -209,  -209,   158,
     138,   177,  -209,  -209,  -209,  -209,   176,  -209,   190,   457,
     359,     5,  -209,   359,  -209,  -209,   114,  -209,   149,  -209,
     162,  -209,   169,   100,  -209,   173,   186,  -209,  -209,  -209,
     199,    99,    93,    96,   105,    83,   131,   131,   153,   153,
     153,   153,   -12,   -12,  -209,  -209,  -209,   174,   174,   359,
      -3,   359,  -209,  -209,   138,   359,   359,  -209,  -209,  -209,
    -209,  -209,  -209,  -209,  -209,  -209,  -209,   437,   359,   437,
    -209,   359,   194,   179,  -209,   359,  -209,  -209,  -209,  -209,
    -209,  -209,   359,   236,    23,   238,   245,   249,  -209,  -209,
    -209,   359,  -209,  -209,  -209,  -209,   359,  -209,  -209,  -209,
      42,    42,    42,    42,  -209,   209,  -209,  -209,  -209,     4,
    -209,  -209,  -209
  };

  const unsigned char
   Parser ::yydefact_[] =
  {
       6,     6,     6,     6,     0,    25,     3,     4,     5,     1,
      25,     8,    27,    12,    13,     7,    10,    25,     0,     0,
      18,    22,    23,    29,    20,    21,    19,   124,   125,   126,
     123,    16,    15,    28,    17,   127,    24,    14,    11,     0,
       0,    85,     0,    82,    84,    83,    59,   125,    60,    55,
      57,   138,   140,   122,    58,    62,    65,    77,    68,   117,
       0,     0,    86,    87,    89,    91,    93,    95,    97,    99,
     102,   114,   107,   110,    56,     0,    70,   142,   141,    63,
      34,     9,    55,     0,    73,    78,   121,    74,    79,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    76,    26,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    81,
      80,    71,    72,     0,     0,     0,    42,    41,    40,     0,
      34,    32,    38,    35,    36,    39,    68,    37,   142,   141,
       0,     0,    61,     0,   134,   144,     0,   128,     0,   130,
       0,   132,     0,     0,   136,     0,     0,    75,    66,    67,
       0,    90,    92,    94,    96,    98,   100,   101,   103,   104,
     105,   106,   108,   109,   111,   112,   113,   115,   116,     0,
       0,     0,    30,    33,    34,     0,     0,   145,   154,   153,
     150,   152,   149,   151,   146,   147,   148,     0,     0,     0,
     118,     0,     0,     0,   135,     0,   129,   131,   133,   139,
     137,    69,     0,     0,     0,     0,     0,     0,    31,    50,
      51,     0,    53,    52,    54,   119,     0,    64,   143,    88,
       0,     0,     0,     0,   120,    46,    44,    43,    45,     0,
      48,    49,    47
  };

  const short
   Parser ::yypgoto_[] =
  {
    -209,  -209,   237,  -209,   251,  -209,   250,  -209,  -209,   -10,
    -208,  -123,  -209,  -209,  -209,  -209,    29,  -209,  -209,  -209,
    -209,   -79,  -170,  -209,   -18,    50,  -209,   178,   168,   175,
     180,   172,   122,    47,   136,   145,   -57,   106,    -8,  -209,
     -78,   -75,   205,    28,   144
  };

  const short
   Parser ::yydefgoto_[] =
  {
      -1,     4,     5,    10,    11,    12,    13,    14,    19,    55,
      81,   129,   130,   131,   132,   133,   134,   242,   135,    56,
      57,    58,    59,    60,   145,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,   146,   197
  };

  const short
   Parser ::yytable_[] =
  {
      61,   136,   138,    98,    36,   139,    37,   183,   119,    80,
      89,    23,    39,   144,   117,   201,   142,    23,    91,   143,
     120,    83,   235,   236,   237,   238,   118,   222,  -124,   224,
      40,   240,    84,    20,    87,   214,  -126,    21,    22,    95,
    -124,    41,    42,    43,    23,   202,   100,    80,  -126,    44,
      45,   136,   138,     9,   123,   139,    24,   174,   175,   176,
     101,   218,   137,    46,    47,    48,    49,   121,    33,    53,
      25,    50,    51,    52,    33,    53,    54,   156,    26,   122,
      96,    97,   160,   200,    16,    -2,    92,   140,   158,   159,
      27,    28,    29,    30,    31,    86,    92,    17,    32,   106,
     107,    33,    34,    35,  -123,   136,   138,    90,   209,   139,
      94,    93,   137,   205,  -123,    99,  -123,   141,   148,   150,
     152,   153,   155,   102,   204,    18,  -123,   205,  -127,    27,
      28,    29,    30,    27,    28,    29,    30,   103,    51,    52,
    -127,   104,    35,   179,   225,   157,    35,    39,   105,   108,
     109,   180,    23,   110,   111,   168,   169,   170,   171,   206,
     181,   213,   205,   217,   182,    40,   137,   219,   220,   234,
     215,   203,   207,   112,   113,   205,    41,    42,    43,   208,
     223,   184,   205,   210,    44,    45,   205,   228,   123,   227,
     124,   185,   205,   125,   211,   126,   127,   128,    46,    47,
      48,    49,   212,    83,   226,   186,    50,    51,    52,    33,
      53,    54,    39,   147,   114,   115,   116,    23,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   166,   167,
      40,    27,    28,    29,    30,     1,     2,     3,     6,     7,
       8,    41,    42,    43,    35,    85,   230,    88,   231,    44,
      45,    39,   149,   177,   178,   232,    23,   172,   173,   233,
     239,    15,   229,    46,    47,    48,    49,    38,   241,    40,
     162,    50,    51,    52,    33,    53,    54,   165,   163,   161,
      41,    42,    43,   199,   164,     0,   216,     0,    44,    45,
      39,   151,     0,     0,     0,    23,     0,     0,     0,     0,
       0,     0,    46,    47,    48,    49,     0,     0,    40,     0,
      50,    51,    52,    33,    53,    54,     0,     0,     0,    41,
      42,    43,     0,     0,     0,     0,     0,    44,    45,    39,
     154,     0,     0,     0,    23,     0,     0,     0,     0,     0,
       0,    46,    47,    48,    49,     0,     0,    40,     0,    50,
      51,    52,    33,    53,    54,     0,     0,     0,    41,    42,
      43,     0,     0,     0,     0,     0,    44,    45,    39,     0,
       0,     0,     0,    23,     0,     0,     0,     0,     0,     0,
      46,    47,    48,    49,     0,     0,    40,     0,    50,    51,
      52,    33,    53,    54,     0,     0,     0,    41,    42,    43,
       0,     0,     0,     0,     0,    44,    45,    39,     0,     0,
       0,     0,    23,     0,     0,     0,     0,     0,     0,    46,
      47,    48,    49,     0,     0,    40,     0,    50,    51,    52,
      33,    53,    54,     0,     0,     0,    41,    42,    43,     0,
       0,     0,     0,     0,    44,    45,   221,     0,     0,     0,
       0,    23,     0,     0,     0,     0,     0,     0,    46,    47,
      48,    82,     0,     0,    40,     0,    50,    51,    52,    33,
      53,    54,   198,     0,     0,    41,    42,    43,     0,     0,
       0,     0,     0,    44,    45,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,     0,     0,    46,    47,    48,
      49,     0,     0,     0,     0,    50,    51,    52,    33,    53,
      54
  };

  const short
   Parser ::yycheck_[] =
  {
      18,    80,    80,    60,    14,    80,    14,   130,    27,     5,
       9,    14,     9,    10,    26,    10,    10,    14,     9,    13,
      39,    39,   230,   231,   232,   233,    38,   197,    27,   199,
      27,   239,    40,     3,    42,    38,    27,     7,     8,     7,
      39,    38,    39,    40,    14,    40,    11,     5,    39,    46,
      47,   130,   130,     0,    50,   130,    26,   114,   115,   116,
      25,   184,    80,    60,    61,    62,    63,    27,    71,    72,
      40,    68,    69,    70,    71,    72,    73,    95,    48,    39,
      48,    49,   100,   140,     0,     0,     9,    10,    96,    97,
      60,    61,    62,    63,    64,    72,     9,    13,    68,    16,
      17,    71,    72,    73,    27,   184,   184,     9,     8,   184,
       9,     7,   130,    13,    27,    12,    39,    40,    90,    91,
      92,    93,    94,    24,    10,    41,    39,    13,    27,    60,
      61,    62,    63,    60,    61,    62,    63,    44,    69,    70,
      39,    45,    73,     9,   201,    72,    73,     9,    43,    18,
      19,     9,    14,    22,    23,   108,   109,   110,   111,    10,
       9,   179,    13,   181,     6,    27,   184,   185,   186,   226,
     180,   143,    10,    20,    21,    13,    38,    39,    40,    10,
     198,     4,    13,    10,    46,    47,    13,   205,    50,    10,
      52,    15,    13,    55,     8,    57,    58,    59,    60,    61,
      62,    63,     3,   221,    10,    15,    68,    69,    70,    71,
      72,    73,     9,    10,    40,    41,    42,    14,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,   106,   107,
      27,    60,    61,    62,    63,    65,    66,    67,     1,     2,
       3,    38,    39,    40,    73,    40,    10,    42,    10,    46,
      47,     9,    10,   117,   118,    10,    14,   112,   113,    10,
      51,    10,   212,    60,    61,    62,    63,    17,   239,    27,
     102,    68,    69,    70,    71,    72,    73,   105,   103,   101,
      38,    39,    40,   139,   104,    -1,   180,    -1,    46,    47,
       9,    10,    -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    60,    61,    62,    63,    -1,    -1,    27,    -1,
      68,    69,    70,    71,    72,    73,    -1,    -1,    -1,    38,
      39,    40,    -1,    -1,    -1,    -1,    -1,    46,    47,     9,
      10,    -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    60,    61,    62,    63,    -1,    -1,    27,    -1,    68,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    38,    39,
      40,    -1,    -1,    -1,    -1,    -1,    46,    47,     9,    -1,
      -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    61,    62,    63,    -1,    -1,    27,    -1,    68,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    38,    39,    40,
      -1,    -1,    -1,    -1,    -1,    46,    47,     9,    -1,    -1,
      -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,    60,
      61,    62,    63,    -1,    -1,    27,    -1,    68,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    38,    39,    40,    -1,
      -1,    -1,    -1,    -1,    46,    47,     9,    -1,    -1,    -1,
      -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,
      62,    63,    -1,    -1,    27,    -1,    68,    69,    70,    71,
      72,    73,    15,    -1,    -1,    38,    39,    40,    -1,    -1,
      -1,    -1,    -1,    46,    47,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    -1,    -1,    60,    61,    62,
      63,    -1,    -1,    -1,    -1,    68,    69,    70,    71,    72,
      73
  };

  const signed char
   Parser ::yystos_[] =
  {
       0,    65,    66,    67,    75,    76,    76,    76,    76,     0,
      77,    78,    79,    80,    81,    78,     0,    13,    41,    82,
       3,     7,     8,    14,    26,    40,    48,    60,    61,    62,
      63,    64,    68,    71,    72,    73,    83,   112,    80,     9,
      27,    38,    39,    40,    46,    47,    60,    61,    62,    63,
      68,    69,    70,    72,    73,    83,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
       5,    84,    63,    98,   112,   116,    72,   112,   116,     9,
       9,     9,     9,     7,     9,     7,    48,    49,   110,    12,
      11,    25,    24,    44,    45,    43,    16,    17,    18,    19,
      22,    23,    20,    21,    40,    41,    42,    26,    38,    27,
      39,    27,    39,    50,    52,    55,    57,    58,    59,    85,
      86,    87,    88,    89,    90,    92,    95,    98,   114,   115,
      10,    40,    10,    13,    10,    98,   117,    10,   117,    10,
     117,    10,   117,   117,    10,   117,    98,    72,   112,   112,
      98,   101,   102,   103,   104,   105,   106,   106,   107,   107,
     107,   107,   109,   109,   110,   110,   110,   108,   108,     9,
       9,     9,     6,    85,     4,    15,    15,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,   118,    15,   118,
     110,    10,    40,   117,    10,    13,    10,    10,    10,     8,
      10,     8,     3,    98,    38,    83,   111,    98,    85,    98,
      98,     9,    96,    98,    96,   110,    10,    10,    98,    99,
      10,    10,    10,    10,   110,    84,    84,    84,    84,    51,
      84,    90,    91
  };

  const signed char
   Parser ::yyr1_[] =
  {
       0,    74,    75,    76,    76,    76,    76,    77,    77,    78,
      78,    79,    79,    80,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    82,    82,    83,    83,
      84,    85,    85,    85,    85,    86,    86,    87,    87,    87,
      88,    88,    88,    89,    89,    89,    90,    90,    91,    91,
      92,    92,    92,    92,    92,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    95,    96,    96,    96,    96,
      96,    96,    97,    97,    97,    97,    98,    99,    99,   100,
     100,   101,   101,   102,   102,   103,   103,   104,   104,   105,
     105,   105,   106,   106,   106,   106,   106,   107,   107,   107,
     108,   108,   108,   108,   109,   109,   109,   110,   110,   110,
     110,   111,   111,   112,   112,   112,   112,   112,   113,   113,
     113,   113,   113,   113,   113,   113,   113,   113,   114,   114,
     115,   116,   116,   117,   117,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118
  };

  const signed char
   Parser ::yyr2_[] =
  {
       0,     2,     2,     2,     2,     2,     0,     2,     1,     3,
       2,     3,     1,     1,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     0,     3,     0,     1,     1,
       3,     3,     1,     2,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     5,     5,     5,     7,     1,     1,
       3,     3,     3,     3,     3,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     5,     1,     3,     3,     1,     4,
       1,     2,     2,     2,     2,     3,     2,     1,     2,     2,
       2,     2,     1,     1,     1,     1,     1,     1,     5,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     3,     1,     3,     3,     3,     3,     1,     3,     3,
       1,     3,     3,     3,     1,     3,     3,     1,     4,     5,
       6,     2,     1,     1,     1,     1,     1,     1,     3,     4,
       3,     4,     3,     4,     3,     4,     3,     4,     1,     4,
       1,     1,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const  Parser ::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "\":\"", "\";\"",
  "\"{\"", "\"}\"", "\"[\"", "\"]\"", "\"(\"", "\")\"", "\"?\"",
  "\"end predicate\"", "\",\"", "\"$#\"", "\"=\"", "\"==\"", "\"!=\"",
  "\"<=\"", "\">=\"", "\"<<\"", "\">>\"", "\"<\"", "\">\"", "\"&&\"",
  "\"||\"", "\"+\"", "\"++\"", "\"<<=\"", "\">>=\"", "\"+=\"", "\"-=\"",
  "\"*=\"", "\"/=\"", "\"%=\"", "\"&=\"", "\"|=\"", "\"^=\"", "\"-\"",
  "\"--\"", "\"*\"", "\"/\"", "\"%\"", "\"&\"", "\"|\"", "\"^\"", "\"!\"",
  "\"~\"", "\".\"", "\"->\"", "\"if\"", "\"else\"", "\"unroll\"",
  "\"struct\"", "\"union\"", "\"while\"", "\"for\"", "\"return\"",
  "\"continue\"", "\"break\"", "\"builtin\"", "\"call\"",
  "\"call_builtin\"", "\"identifier\"", "\"path\"",
  "\"preprocessor directive\"", "\"struct definition\"", "\"enum\"",
  "\"string\"", "\"map\"", "\"variable\"", "\"positional parameter\"",
  "\"integer\"", "\"stack_mode\"", "$accept", "program", "c_definitions",
  "probes", "probe", "attach_points", "attach_point", "attach_point_def",
  "pred", "param", "block", "stmt_list", "block_stmt", "expr_stmt",
  "jump_stmt", "loop_stmt", "if_stmt", "block_or_if", "assign_stmt",
  "primary_expr", "postfix_expr", "tuple_access_expr", "unary_expr",
  "unary_op", "expr", "conditional_expr", "logical_or_expr",
  "logical_and_expr", "or_expr", "xor_expr", "and_expr", "equality_expr",
  "relational_expr", "shift_expr", "muli_expr", "addi_expr", "cast_expr",
  "int", "ident", "call", "map", "var", "map_or_var", "vargs",
  "compound_op", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
   Parser ::yyrline_[] =
  {
       0,   158,   158,   162,   163,   164,   165,   169,   170,   174,
     184,   197,   198,   202,   206,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   232,   236,   237,   242,   253,
     257,   264,   265,   269,   270,   274,   275,   279,   280,   285,
     289,   290,   291,   295,   296,   297,   301,   302,   306,   307,
     311,   316,   317,   318,   323,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   350,   352,   353,   355,   357,
     358,   359,   360,   362,   363,   368,   374,   375,   376,   377,
     379,   380,   384,   385,   386,   387,   391,   395,   396,   401,
     402,   406,   407,   411,   412,   416,   417,   422,   423,   427,
     428,   429,   433,   434,   435,   436,   437,   441,   442,   443,
     447,   448,   449,   450,   454,   455,   456,   460,   461,   462,
     463,   467,   468,   472,   473,   474,   475,   476,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   493,   494,
     498,   502,   503,   507,   508,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521
  };

  void
   Parser ::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
   Parser ::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 4 "src/parser.yy"
} //  bpftrace 
#line 2754 "/builddir/build/BUILD/bpftrace-0.13.1/redhat-linux-build/parser.tab.cc"

#line 524 "src/parser.yy"


void bpftrace::Parser::error(const location &l, const std::string &m)
{
  driver.error(l, m);
}
